﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Documents.Excel;
using System.Collections;


namespace ExcelWorkbookWithLargeData
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public ObservableCollection<Data> largeData;
   
        public MainWindow()
        {
            InitializeComponent();
            largeData = Data.GetData(700000, 1, 2);
        }
       
        private void Button_Click(object sender, RoutedEventArgs e)
        {
            Workbook dataWorkbook = new Workbook(WorkbookFormat.Excel2007);
            Worksheet sheetOne = dataWorkbook.Worksheets.Add("DataSheet");

            // Print column header text 
              sheetOne.Rows[0].Cells[0].Value = "Value";
              sheetOne.Rows[0].Cells[1].Value = "Date";
              sheetOne.Rows[0].Cells[2].Value = "Label";

            //  var xlsx = Workbook.MaxExcel2007RowCount;

            // Export Data From Collection
            int currentRow = 1;
            WorksheetRow worksheetRow;
            foreach (var i in largeData)
            {
                int currentCell = 0;
                worksheetRow = sheetOne.Rows[currentRow];
                worksheetRow.Cells[currentCell].Value   = i.Value;
                worksheetRow.Cells[++currentCell].Value = i.Date;
                worksheetRow.Cells[++currentCell].Value = i.Label;
                currentRow++;
            }
          
            var p = sheetOne.Rows.Count();
           
            string fileName = @"test2.xlsx";
            dataWorkbook.Save(fileName);
        }

    }

 
	
    
    public class Data : INotifyPropertyChanged
    {
       
        private int value;
        private string label;
        private DateTime date;


        public DateTime Date
        {
            get { return date; }
            set
            {
                date = value;
                PropChanged("Date");
            }
        }


        public string Label
        {
            get { return label; }
            set
            {
                label = value;
                PropChanged("Label");
            }
        }

        

        

        


        public int Value
        {
            get { return value; }
            set
            {
                this.value = value;
                PropChanged("Value");
            }
        }


        public static ObservableCollection<Data> GetData(int points, int rangeStart, int rangeEnd)
        {
            ObservableCollection<Data> data = new ObservableCollection<Data>();
            Random r = new Random();
            for (int i = 0; i < points; i++)
            {
                data.Add(new Data
                {
                    Date = DateTime.Now.AddDays(i),
                    Label = "Item " + i,
                    Value = r.Next(rangeStart, rangeEnd),
                });
            }

            return data;
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void PropChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    } 
				
}
